//+------------------------------------------------------------------+
//|                                   ForexTeach_USDx V001.00.01.mq4 |
//|                                       http://www.forexteach.com  |
//+------------------------------------------------------------------+
#property copyright "forexteach.com"
#property link      "http://www.forexteach.com"
#property show_inputs
#include <WinUser32.mqh>

#define  CHART_CMD_UPDATE_DATA            33324

extern int ExtPeriodMultiplier=5; // new period multiplier factor
extern int StartBars=1000;
extern int timesleep=100;
extern string version="ForexTeach_USDx V001.00.01";
extern int     UpdateInterval = 0;        // update interval in milliseconds, zero means update real-time.
int        ExtHandle=-1;
double _open, _low, _high, _close, _volume;
datetime _time;
int c_period=0,int_period=0;
double     EUR[][6];
double     JPY[][6];
double     GBP[][6];
double     CHF[][6];
double     CAD[][6];
double     SEK[][6];
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
   int    i, start_pos, i_time, time0, last_fpos, periodseconds;
   double d_open, d_low, d_high, d_close, d_volume, last_volume;
   int    hwnd=0,cnt=0;
//---- History header
   int    version=400;
   string c_copyright;
   string c_symbol="FTUSDx";
   int    i_period=Period()*ExtPeriodMultiplier;
   int    i_digits=Digits;
   int    i_unused[13];
//----  
   ExtHandle=FileOpenHistory(c_symbol+i_period+".hst", FILE_BIN|FILE_WRITE);
   if(ExtHandle < 0) return(-1);
//---- write history file header
   c_copyright="(C)opyright 2003, MetaQuotes Software Corp.";
   FileWriteInteger(ExtHandle, version, LONG_VALUE);
   FileWriteString(ExtHandle, c_copyright, 64);
   FileWriteString(ExtHandle, c_symbol, 12);
   FileWriteInteger(ExtHandle, i_period, LONG_VALUE);
   FileWriteInteger(ExtHandle, i_digits, LONG_VALUE);
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);       //timesign
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);       //last_sync
   FileWriteArray(ExtHandle, i_unused, 0, 13);
//---- write history file

//---- LOad HIstory data.
   ArrayCopyRates(EUR,"EURUSD", Period());
   ArrayCopyRates(JPY,"USDJPY", Period());
   ArrayCopyRates(GBP,"GBPUSD", Period());
   ArrayCopyRates(CHF,"USDCHF", Period());
   ArrayCopyRates(CAD,"USDCAD", Period());
   ArrayCopyRates(SEK,"USDSEK", Period());
//---- LOad HIstory data.
   periodseconds=i_period*60;
   start_pos=Bars-1;
Print("abbbbbbbbbaaaaaaaaaaaa");   
   //----
   //d_open=Open[start_pos];
   //d_low=Low[start_pos];
   //d_high=High[start_pos];
   //d_volume=Volume[start_pos];
   if (EUR[i][1] == 0 ||
       JPY[i][1] == 0 ||
       GBP[i][1] == 0 ||
       CHF[i][1] == 0 ||
       CAD[i][1] == 0 ||
       SEK[i][1] == 0 ||
       EUR[i][2] == 0 ||
       JPY[i][2] == 0 ||
       GBP[i][2] == 0 ||
       CHF[i][2] == 0 ||
       CAD[i][2] == 0 ||
       SEK[i][2] == 0 ||
       EUR[i][3] == 0 ||
       JPY[i][3] == 0 ||
       GBP[i][3] == 0 ||
       CHF[i][3] == 0 ||
       CAD[i][3] == 0 ||
       SEK[i][3] == 0 ||
       EUR[i][4] == 0 ||
       JPY[i][4] == 0 ||
       GBP[i][4] == 0 ||
       CHF[i][4] == 0 ||
       CAD[i][4] == 0 ||
       SEK[i][4] == 0    )
       {
       return(0);
       }
Print("ccccccccccccccccccccc");   
   d_open = MathPow(MathAbs(1/EUR[start_pos][1]+Point),0.576)*
            MathPow(JPY[start_pos][1],0.136)*
            MathPow(MathAbs(1/GBP[start_pos][1]+Point),0.119)*
            MathPow(CHF[start_pos][1],0.036)*
            MathPow(CAD[start_pos][1],0.091)*
            MathPow(SEK[start_pos][1],0.042)*50.14348112;
Print("111111111111111111111");   
   d_low =  MathPow(MathAbs(1/EUR[start_pos][2]+Point),0.576)*
            MathPow(JPY[start_pos][2],0.136)*
            MathPow(MathAbs(1/GBP[start_pos][2]+Point),0.119)*
            MathPow(CHF[start_pos][2],0.036)*
            MathPow(CAD[start_pos][2],0.091)*
            MathPow(SEK[start_pos][2],0.042)*50.14348112;
Print("222222222222222222222");   
   d_high = MathPow(MathAbs(1/EUR[start_pos][3]+Point),0.576)*
            MathPow(JPY[start_pos][3],0.136)*
            MathPow(MathAbs(1/GBP[start_pos][3]+Point),0.119)*
            MathPow(CHF[start_pos][3],0.036)*
            MathPow(CAD[start_pos][3],0.091)*
            MathPow(SEK[start_pos][3],0.042)*50.14348112;
Print("333333333333333333");   
   d_close= MathPow(MathAbs(1/EUR[start_pos][4]+Point),0.576)*
            MathPow(JPY[start_pos][4],0.136)*
            MathPow(MathAbs(1/GBP[start_pos][4]+Point),0.119)*
            MathPow(CHF[start_pos][4],0.036)*
            MathPow(CAD[start_pos][4],0.091)*
            MathPow(SEK[start_pos][4],0.042)*50.14348112;
Print("444444444444444444444444444");   
   d_volume = iVolume("GBPUSD",Period(),start_pos);
Print("dddddddddddddddddddd");   
   //----
   //---- normalize open time
   i_time=Time[start_pos]/periodseconds;
   i_time*=periodseconds;
   for(i=start_pos-1;i>StartBars; i--)
     {
      time0=Time[i];
      if(time0>=i_time+periodseconds || i==0)
        {
         if(i==0 && time0<i_time+periodseconds)
           {
            //----
            if (EUR[i][1] == 0 ||
                JPY[i][1] == 0 ||
                GBP[i][1] == 0 ||
                CHF[i][1] == 0 ||
                CAD[i][1] == 0 ||
                SEK[i][1] == 0 ||
                EUR[i][2] == 0 ||
                JPY[i][2] == 0 ||
                GBP[i][2] == 0 ||
                CHF[i][2] == 0 ||
                CAD[i][2] == 0 ||
                SEK[i][2] == 0 ||
                EUR[i][3] == 0 ||
                JPY[i][3] == 0 ||
                GBP[i][3] == 0 ||
                CHF[i][3] == 0 ||
                CAD[i][3] == 0 ||
                SEK[i][3] == 0 ||
                EUR[i][4] == 0 ||
                JPY[i][4] == 0 ||
                GBP[i][4] == 0 ||
                CHF[i][4] == 0 ||
                CAD[i][4] == 0 ||
                SEK[i][4] == 0    )
                {
                continue;
                }
            _open = MathPow(MathAbs(1/EUR[start_pos][1]+Point),0.576)*
                     MathPow(JPY[start_pos][1],0.136)*
                     MathPow(MathAbs(1/GBP[start_pos][1]+Point),0.119)*
                     MathPow(CHF[start_pos][1],0.036)*
                     MathPow(CAD[start_pos][1],0.091)*
                     MathPow(SEK[start_pos][1],0.042)*50.14348112;
            _low =  MathPow(MathAbs(1/EUR[start_pos][2]+Point),0.576)*
                     MathPow(JPY[start_pos][2],0.136)*
                     MathPow(MathAbs(1/GBP[start_pos][2]+Point),0.119)*
                     MathPow(CHF[start_pos][2],0.036)*
                     MathPow(CAD[start_pos][2],0.091)*
                     MathPow(SEK[start_pos][2],0.042)*50.14348112;
            _high = MathPow(MathAbs(1/EUR[start_pos][3]+Point),0.576)*
                     MathPow(JPY[start_pos][3],0.136)*
                     MathPow(MathAbs(1/GBP[start_pos][3]+Point),0.119)*
                     MathPow(CHF[start_pos][3],0.036)*
                     MathPow(CAD[start_pos][3],0.091)*
                     MathPow(SEK[start_pos][3],0.042)*50.14348112;
            _close= MathPow(MathAbs(1/EUR[start_pos][4]+Point),0.576)*
                     MathPow(JPY[start_pos][4],0.136)*
                     MathPow(MathAbs(1/GBP[start_pos][4]+Point),0.119)*
                     MathPow(CHF[start_pos][4],0.036)*
                     MathPow(CAD[start_pos][4],0.091)*
                     MathPow(SEK[start_pos][4],0.042)*50.14348112;
            //----
            d_volume+=iVolume("GBPUSD",Period(),start_pos);
            if (_low<d_low)   d_low=_low;
            if (_high>d_high) d_high=_high;
            d_close=_close;
           }
         last_fpos=FileTell(ExtHandle);
         last_volume=iVolume("GBPUSD",Period(),i);
         FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
         FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_open),2), DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_low),2), DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_high),2), DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_close),2), DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_volume),2), DOUBLE_VALUE);
         FileFlush(ExtHandle);
         cnt++;
         if(time0>=i_time+periodseconds)
           {
            i_time=time0/periodseconds;
            i_time*=periodseconds;
            //----
            //d_open=Open[i];
            //d_low=Low[i];
            //d_high=High[i];
            //d_close=Close[i];
            if (EUR[i][1] == 0 ||
                JPY[i][1] == 0 ||
                GBP[i][1] == 0 ||
                CHF[i][1] == 0 ||
                CAD[i][1] == 0 ||
                SEK[i][1] == 0 ||
                EUR[i][2] == 0 ||
                JPY[i][2] == 0 ||
                GBP[i][2] == 0 ||
                CHF[i][2] == 0 ||
                CAD[i][2] == 0 ||
                SEK[i][2] == 0 ||
                EUR[i][3] == 0 ||
                JPY[i][3] == 0 ||
                GBP[i][3] == 0 ||
                CHF[i][3] == 0 ||
                CAD[i][3] == 0 ||
                SEK[i][3] == 0 ||
                EUR[i][4] == 0 ||
                JPY[i][4] == 0 ||
                GBP[i][4] == 0 ||
                CHF[i][4] == 0 ||
                CAD[i][4] == 0 ||
                CHF[i][4] == 0    )
                {
                continue;
                }
            d_volume=last_volume;
            d_open = MathPow(MathAbs(1/EUR[i][1]+Point),0.576)*
                     MathPow(JPY[i][1],0.136)*
                     MathPow(MathAbs(1/GBP[i][1]+Point),0.119)*
                     MathPow(CHF[i][1],0.036)*
                     MathPow(CAD[i][1],0.091)*
                     MathPow(SEK[i][1],0.042)*50.14348112;
            d_low =  MathPow(MathAbs(1/EUR[i][2]+Point),0.576)*
                     MathPow(JPY[i][2],0.136)*
                     MathPow(MathAbs(1/GBP[i][2]+Point),0.119)*
                     MathPow(CHF[i][2],0.036)*
                     MathPow(CAD[i][2],0.091)*
                     MathPow(SEK[i][2],0.042)*50.14348112;
            d_high = MathPow(MathAbs(1/EUR[i][3]+Point),0.576)*
                     MathPow(JPY[i][3],0.136)*
                     MathPow(MathAbs(1/GBP[i][3]+Point),0.119)*
                     MathPow(CHF[i][3],0.036)*
                     MathPow(CAD[i][3],0.091)*
                     MathPow(SEK[i][3],0.042)*50.14348112;
            d_close= MathPow(MathAbs(1/EUR[i][4]+Point),0.576)*
                     MathPow(JPY[i][4],0.136)*
                     MathPow(MathAbs(1/GBP[i][4]+Point),0.119)*
                     MathPow(CHF[i][4],0.036)*
                     MathPow(CAD[i][4],0.091)*
                     MathPow(SEK[i][4],0.042)*50.14348112;
            //----
           }
        }
       else
        {
         //d_volume+=Volume[i];
         //if (Low[i]<d_low)   d_low=Low[i];
         //if (High[i]>d_high) d_high=High[i];
         //d_close=Close[i];
         if (EUR[i][1] == 0 ||
             JPY[i][1] == 0 ||
             GBP[i][1] == 0 ||
             CHF[i][1] == 0 ||
             CAD[i][1] == 0 ||
             SEK[i][1] == 0 ||
             EUR[i][2] == 0 ||
             JPY[i][2] == 0 ||
             GBP[i][2] == 0 ||
             CHF[i][2] == 0 ||
             CAD[i][2] == 0 ||
             SEK[i][2] == 0 ||
             EUR[i][3] == 0 ||
             JPY[i][3] == 0 ||
             GBP[i][3] == 0 ||
             CHF[i][3] == 0 ||
             CAD[i][3] == 0 ||
             CHF[i][3] == 0 ||
             EUR[i][4] == 0 ||
             CAD[i][4] == 0 ||
             JPY[i][4] == 0 ||
             CHF[i][4] == 0 ||
             CAD[i][4] == 0 ||
             SEK[i][4] == 0    )
             {
             continue;
             }
         _open =  MathPow(MathAbs(1/EUR[i][1]+Point),0.576)*
                  MathPow(JPY[i][1],0.136)*
                  MathPow(MathAbs(1/GBP[i][1]+Point),0.119)*
                  MathPow(CAD[i][1],0.036)*
                  MathPow(CAD[i][1],0.091)*
                  MathPow(SEK[i][1],0.042)*50.14348112;
         _low =   MathPow(MathAbs(1/EUR[i][2]+Point),0.576)*
                  MathPow(JPY[i][2],0.136)*
                  MathPow(MathAbs(1/GBP[i][2]+Point),0.119)*
                  MathPow(CHF[i][2],0.036)*
                  MathPow(CAD[i][2],0.091)*
                  MathPow(SEK[i][2],0.042)*50.14348112;
         _high =  MathPow(MathAbs(1/EUR[i][3]+Point),0.576)*
                  MathPow(JPY[i][3],0.136)*
                  MathPow(MathAbs(1/GBP[i][3]+Point),0.119)*
                  MathPow(CHF[i][3],0.036)*
                  MathPow(CAD[i][3],0.091)*
                  MathPow(SEK[i][3],0.042)*50.14348112;
         _close=  MathPow(MathAbs(1/GBP[i][4]+Point),0.576)*
                  MathPow(JPY[i][4],0.136)*
                  MathPow(MathAbs(1/GBP[i][4]+Point),0.119)*
                  MathPow(CHF[i][4],0.036)*
                  MathPow(CAD[i][4],0.091)*
                  MathPow(SEK[i][4],0.042)*50.14348112;
         d_volume +=  iVolume("GBPUSD",Period(),i);
         if (_low<d_low) d_low = _low;
         if (_high>d_high) d_high = _high;
         d_close = _close;      
        }
     } 
   FileFlush(ExtHandle);
   Print(cnt," record(s) written");
//---- collect incoming ticks
   int last_time=LocalTime()-5;
   while(IsStopped()==false)
       {
       Sleep(100);
       UpdateChartWindow();
//       UpdateChartWindow();
       int cur_time=_time;
      //---- check for new rates
      if(RefreshRates())
        {
         time0=_time;
         FileSeek(ExtHandle,last_fpos,SEEK_SET);
         //---- is there current bar?
         if(time0<i_time+periodseconds)
           {
            d_volume+=_volume-last_volume;
            last_volume=_volume; 
            if (_low<d_low) d_low=_low;
            if (_high>d_high) d_high=_high;
            d_close=_close;
           }
         else
           {
            //---- no, there is new bar
            //d_volume+=Volume[i+1]-last_volume;
            //if (Low[i+1]<d_low) d_low=Low[i+1];
            //if (High[i+1]>d_high) d_high=High[i+1];
            if (EUR[i][1] == 0 ||
                CHF[i][1] == 0 ||
                JPY[i][1] == 0 ||
                CHF[i][1] == 0 ||
                CAD[i][1] == 0 ||
                SEK[i][1] == 0 ||
                EUR[i][2] == 0 ||
                JPY[i][2] == 0 ||
                GBP[i][2] == 0 ||
                CHF[i][2] == 0 ||
                CAD[i][2] == 0 ||
                SEK[i][2] == 0 ||
                EUR[i][3] == 0 ||
                CAD[i][3] == 0 ||
                JPY[i][3] == 0 ||
                CHF[i][3] == 0 ||
                CAD[i][3] == 0 ||
                SEK[i][3] == 0 ||
                EUR[i][4] == 0 ||
                JPY[i][4] == 0 ||
                GBP[i][4] == 0 ||
                CHF[i][4] == 0 ||
                CAD[i][4] == 0 ||
                SEK[i][4] == 0    )
                {
                continue;
                }
            _open =  MathPow(MathAbs(1/GBP[i][1]+Point),0.576)*
                     MathPow(JPY[i][1],0.136)*
                     MathPow(MathAbs(1/GBP[i][1]+Point),0.119)*
                     MathPow(CHF[i][1],0.036)*
                     MathPow(CAD[i][1],0.091)*
                     MathPow(SEK[i][1],0.042)*50.14348112;
            _low =   MathPow(MathAbs(1/EUR[i][2]+Point),0.576)*
                     MathPow(JPY[i][2],0.136)*
                     MathPow(MathAbs(1/GBP[i][2]+Point),0.119)*
                     MathPow(CHF[i][2],0.036)*
                     MathPow(CAD[i][2],0.091)*
                     MathPow(SEK[i][2],0.042)*50.14348112;
            _high =  MathPow(MathAbs(1/GBP[i][3]+Point),0.576)*
                     MathPow(JPY[i][3],0.136)*
                     MathPow(MathAbs(1/GBP[i][3]+Point),0.119)*
                     MathPow(CHF[i][3],0.036)*
                     MathPow(CAD[i][3],0.091)*
                     MathPow(SEK[i][3],0.042)*50.14348112;
            _close=  MathPow(MathAbs(1/EUR[i][4]+Point),0.576)*
                     MathPow(JPY[i][4],0.136)*
                     MathPow(MathAbs(1/GBP[i][4]+Point),0.119)*
                     MathPow(CHF[i][4],0.036)*
                     MathPow(CAD[i][4],0.091)*
                     MathPow(SEK[i][4],0.042)*50.14348112;
            d_volume +=  iVolume("GBPUSD",Period(),i)- last_volume;
            if (_low<d_low) d_low = _low;
            if (_high>d_high) d_high = _high;
            d_close = _close;      
            //---- write previous bar remains
            //FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
            //FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
            //FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
            //FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
            //FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
            //FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
            //----
            FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
            FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_open),2), DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_low),2), DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_high),2), DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_close),2), DOUBLE_VALUE);
            FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_volume),2), DOUBLE_VALUE);
            last_fpos=FileTell(ExtHandle);
            //----
            i_time=time0/periodseconds;
            i_time*=periodseconds;
            d_open=_open;
            d_low=_low;
            d_high=_high;
            d_close=_close;
            d_volume=_volume;
            last_volume=d_volume;
           }
         //----
         //FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
         //FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
         //FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
         //FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
         //FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
         //FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
         FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
         FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_open),2), DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_low),2), DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_high),2), DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_close),2), DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, NormalizeDouble(MathAbs(d_volume),2), DOUBLE_VALUE);
         FileFlush(ExtHandle);
         //----
         if(hwnd==0)
           {
            hwnd=WindowHandle("FTUSDx",i_period);
            if(hwnd!=0) Print("Chart window detected");
           }
         //---- refresh window not frequently than 1 time in 2 seconds
         if(hwnd!=0 && cur_time-last_time>=2)
           {
            PostMessageA(hwnd,WM_COMMAND,33324,0);
            last_time=cur_time;
           }
        } 
     }      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void deinit()
  {
   if(ExtHandle>=0) { FileClose(ExtHandle); ExtHandle=-1; }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int UpdateChartWindow()
{
   static int hwnd = 0;

   if (ExtHandle < 0) {
      //no HST file opened, no need updating.
      return (-1);
   }
   if(hwnd == 0) {
      //trying to detect the chart window for updating
      hwnd = WindowHandle("FTUSDx", ExtPeriodMultiplier);
   }
   if(hwnd!= 0) {
      if (IsDllsAllowed() == false) {
         //DLL calls must be allowed
         Alert("Dll calls must be allowed");
         return (-1);
      }
      if (PostMessageA(hwnd,WM_COMMAND,CHART_CMD_UPDATE_DATA,0) == 0) {
         //PostMessage failed, chart window closed
         hwnd = 0;
      } else {
         //PostMessage succeed
         return (0);
      }
   }
   //window not found or PostMessage failed
   return (-1);
}

//+------------------------------------------------------------------+